; Function Byte2Decimal converts byte in AL to decimal ASCII value
; and store it to AL:DL:DH (hi nibble in AL)
; AH = 3 - number_of_leading_zeros

Byte2Decimal   Proc
		xor	dx,dx
                aam
                mov	dh,al
                mov	al,ah
                aam
                mov	dl,al
                mov	al,ah
                mov	ah,3
		or	al,al
		jnz	no_lead
		dec	ah
		or	dl,dl
		jnz	no_lead
		dec	ah
no_lead:        add	al,'0'
                add	dx,'00'
                ret
Byte2Decimal   EndP
