
         _STACK    SEGMENT PARA STACK 'STACK'
                  DB      40h DUP (?)
         _STACK    ENDS

         _TEXT    SEGMENT WORD PUBLIC 'CODE'
 ASSUME  CS:_TEXT, SS:_STACK, ES:NOTHING

	INCLUDE PREPBYTE.INC
        INCLUDE BYTE2DEC.INC

OEM_Num		DW	22 ; Number of entryes
OEM_Codes	DB	0,1,2,4,5,6,7,0dh,16h,23h,28h,29h,33h,34h,35h,4dh,5eh,66h,99h,0eeh,0efh,0ffh
OEM_Names	DW	IBM,CPQ,MSP,ATT,ZTH,HWP,ZDS,PCB,DEQ,OLV,TXI,TSH,NOV,MSM,MSM,HWP,RXD,PTS,DSE,DRD,NVD,MSD,UNK

IBM		DB	"IBM","$"
CPQ		DB	"Compaq","$"
MSP		DB	"MS Packaged Product","$"
ATT		DB	"AT&T","$"
ZTH             DB      "ZDS (Zenith Electronics)","$"
ZDS             DB      "ZDS (Groupe Bull)","$"
PCB             DB      "Packard-Bell","$"
DEQ             DB      "DEC","$"
OLV             DB      "Olivetti","$"
TXI		DB	"Texas Instruments","$"
TSH             DB      "Toshiba","$"
NOV		DB      "Novell (Windows/386 device IDs only)","$"
MSM		DB      "MS Multimedia Systems (Windows/386 device IDs only)","$"
HWP             DB      "Hewlett-Packard","$"
RXD		DB	"RxDOS","$"
PTS		DB	"PhysTechSoft (PTS-DOS)","$"
DSE             DB      "General Software Embedded DOS","$"
MSD             DB      "Microsoft","$"
DRD		DB	"DR-DOS","$"
NVD		DB	"Novell DOS","$"
UNK             DB      "Unknown","$"

Conc_Num	DW	7
Conc_Codes	DB	32h,41h,50h,60h,62h,66h,67h
Conc_Names	DW	CD32,CD41,CD50,CD60,CD62,CD66,CD67,UndefDOS

CD32		DB	"Concurrent PC DOS 3.2","$"
CD41		DB	"Concurrent DOS 4.1","$"
CD50		DB	"Concurrent DOS/XM 5.0 or Concurrent DOS/386 1.1","$"
CD60		DB	"Concurrent DOS/XM 6.0 or Concurrent DOS/386 2.0","$"
CD62		DB	"Concurrent DOS/XM 6.2 or Concurrent DOS/386 3.0","$"
CD66		DB	"DR Multiuser DOS 5.1","$"
CD67		DB	"Concurrent DOS 5.1","$"

Dr_Num		DW	8
Dr_Codes	DB	60h,63h,64h,65h,67h,70h,71h,72h
Dr_Names	DW	DR60,DR63,DR64,DR65,DR67,DR70,DR71,DR72,UndefDOS1

DR60		DB	"DOS Plus","$"
DR63		DB	"DR-DOS 3.41","$"
DR64		DB	"DR-DOS 3.42","$"
DR65		DB	"DR-DOS 5.00","$"
DR67		DB	"DR-DOS 6.00","$"
DR70		DB	"PalmDOS","$"
DR71		DB	'DR-DOS 6.0 March 1993 "business update"',"$"
DR72		DB	"Novell DOS 7.0","$"


Prog		DB	"== DOSVER 2.0 == (by Yury Semenov 2:467/2@FidoNet)"
NL		DB	13,10,"$"
GVMes		DB	"Get Version reports: $"
DOS		DB	"DOS $"
SerNo		DB	"Serial #$"
NoTrue		DB	"True DOS version info not implemented$"
TrueVer		DB	"True DOS version is $"
Revis		DB	"Revision: $"
instring	DB	"in $"
HMA		DB	"HMA$"
ROM		DB	"ROM$"
Mem		DB	"Conventional memory$"
DRDOS		DB	"DR-DOS version $"
Detected	DB	"detected$"
UndefDOS	DB	"Unknown version of Concurrent DOS $"
UndefDOS1	DB	"Unknown version of DR-DOS $"
SUmess		DB	"[Single user] $"
MUmess		DB	"[Multiuser] $"
OS2mess		DB	"OS/2 detected$"

Space:		mov	dl,' '
TypeChar:	mov	ah,2
		int	21h
                ret

CRLF:		mov	dx,offset NL
TypeStr:	mov	ah,9
		int	21h
                ret

TypeDecByte:	call	Byte2Decimal
		cmp	ah,2
		jz	C2
                cmp	ah,1
                jz	C1
		push	dx
                mov	dl,al
                call	TypeChar
                pop	dx
 C2:            call	TypeChar
 C1:            mov	dl,dh
                call	TypeChar
		ret

TypeHexByte:    call	PrepByte
                push	ax
                mov	dl,ah
                call	TypeChar
                pop	dx
                call	TypeChar
                ret

ShowVer:        push	ax
                call	TypeDecByte
                mov	dl,'.'
                call	TypeChar
                pop	ax
                mov	al,ah
                call	TypeDecByte
                call	Space
                ret

SUproc:
                push	ax
                mov	dx,offset SUmess
                call	TypeStr
                pop	ax
                mov	di,offset DR_Codes
                mov	cx,DR_NUM
                call	XUproc
		mov	dx,DR_Names[bx]
                jmp	TypeStr

MUproc:
                push	ax
                mov	dx,offset MUmess
                call	TypeStr
                pop	ax
                mov	di,offset Conc_Codes
                mov	cx,Conc_NUM
		call	XUproc
                mov	dx,Conc_Names[bx]
                jmp	TypeStr

XUproc:
                mov	bx,cx
                cld
                repnz	scasb
                jz	XU_Found
                dec	cx
XU_Found:	sub	bx,cx
		dec	bx
		shl	bx,1
                ret

DetStr:		call	Space
		mov	dx,offset Detected
                call	TypeStr
                jmp	CRLF

Start:		mov	ax,cs
		mov	ds,ax
                mov	es,ax
                mov	dx,offset Prog
                call	TypeStr
                mov	dx,offset GVMes
                call	TypeStr
		mov	ax,3000h
		int	21h
                or	al,al
                jnz	VersOK
                mov	al,1
VersOK:         push	cx
                push	bx
                push	ax
                mov	al,bh
                mov	di,offset OEM_Codes
                mov	cx,OEM_NUM
                call	XUproc
		mov	dx,OEM_Names[bx]
                call	TypeStr
                call	Space
                mov	dx,offset DOS
                call	TypeStr
                pop	ax
                call	ShowVer
                mov	dx,offset SerNo
                call	TypeStr
                pop	bx
                mov	al,bl
                call	TypeHexByte
                pop	cx
                push	cx
                mov	al,ch
                call	TypeHexByte
                pop	ax
                call	TypeHexByte
		mov	ax,3001h
		int	21h
                cmp	al,5
                jb	NoVerFlag
                test	bh,8
                jz	NoVerFlag
                mov	dx,offset instring
                call	TypeStr
                mov	dx,offset ROM
                call	TypeStr
 NoVerFlag:     call	CRLF
		mov	ax,4451h
                int	21h
                jc	NotConcurr
                cmp	ah,10h
                jz	SU
                cmp	ah,14h
                jz	MU

		mov	dx,offset UndefDOS
		call	TypeStr
Det:            call	DetStr
                jmp	NotConcurr
SU:             call	SUproc
		jmp	Det
MU:             call	MUproc
		jmp	Det

NotConcurr:     mov	ax,4452h
		int	21h
                jc	NotDR
                cmp	ah,10h
                jz	SU1
                cmp	ah,14h
                jz	MU1

		mov	dx,offset UndefDOS1
		call	TypeStr
Det1:           call	DetStr
                jmp	NotDR
SU1:            call	SUproc
		jmp	Det1
MU1:            call	MUproc
		jmp	Det1

NotDR:          clc
		mov	ax,3306h
		int	21h
                jnc	TrueInfo
InvT:           mov	dx,offset NoTrue
                call	TypeStr
                jmp	TruEnd
TrueInfo:       cmp	al,0ffh
		jz	InvT
		mov	ax,bx
		push	dx
                push	ax
                mov	dx,offset TrueVer
                call	TypeStr
                pop	ax
                call	ShowVer
                mov	dl,'('
                call	TypeChar
                mov	dx,offset DOS
                call	TypeStr
                call	Space
                mov	dx,offset instring
                call	TypeStr
                pop	dx
                push	dx
                mov	al,dh
                mov	dx,offset Mem
                cmp	al,8
                jnz	Chk2
                mov	dx,offset ROM
                jmp	TypeLoc
Chk2:           cmp	al,10h
                jnz	TypeLoc
                mov	dx,offset HMA
TypeLoc:        call	TypeStr
		mov	dl,')'
                call	TypeChar
		call	Space
                mov	dx,offset Revis
                call	TypeStr
                pop	dx
                mov	al,dl
                call	TypeDecByte
TruEnd:		call	CRLF

                mov	ax,4010h
                int	2fh
                cmp	ax,4010h
                jz	Exit
                mov	dx,offset OS2mess
                call	TypeStr
                call	CRLF
Exit:
		mov	ax,4c00h
		int	21h

         _TEXT    ENDS

                END	Start
